#include "Rect.hpp"

Rect::Rect(Point center, double width, double height) : Shape(center), width(width), height(height) {}

Rect::~Rect(){
	std::cout << "Destruktor von Rect" << std::endl;
}

double Rect::area(){
	return width*height;
}

double Rect::perimeter(){
	return 2*width + 2*height;
}

bool Rect::inShape(Point p){
	return (p.x >= (center.x - width/2) ) && (p.x <= (center.x + width/2) )
			&& (p.y >= (center.y - height/2) ) && (p.y <= (center.y + height/2) );
}

void Rect::scale(double scaleFactor){
	width = width*scaleFactor;
	height = height*scaleFactor;
}
