#include "Shape.hpp"
#include "Point.hpp"
#include "Rect.hpp"
#include "Square.hpp"
#include "EquiTri.hpp"
#include "Ellipse.hpp"
#include "Circle.hpp"

Shape::Shape(Point center) : center(center) {}

Shape::~Shape(){
	std::cout << "Destruktor von Shape" << std::endl;
}

void Shape::move(Point p){
	center.x += p.x;
	center.y += p.y;
}

int main(){
	Point p(0.0, 1.15);
	Point p2(-1.68, 0.7);
	Shape* shapes [5];
	shapes[0] = new Rect(p, 2.5, 3.0);
	shapes[1] = new Square(p, 4.5);
	shapes[2] = new Ellipse(p, 3, 7);
	shapes[3] = new Circle(p, 2);
	shapes[4] = new EquiTri(p, 4);
	int i = 0;
	for(i = 0; i < 5 ; i++){
		shapes[i]->scale(2);
		shapes[i]->move(Point(3,4));
		std::cout << "\tFläche: " << shapes[i]->area() << "\t | \tUmfang: " << shapes[i]->perimeter() << std::endl;
		std::cout << "Punkt in Shape? " << shapes[i]->inShape(p2) << std::endl;
		delete shapes[i];
	}
	
	Shape* test = new EquiTri(p, 4);
	std::cout << "punkt im dreieck? " << test->inShape(p2) << std::endl;
}

