#ifndef _SHAPE__HPP_
#define _SHAPE__HPP_

#include <iostream>
#include "Point.hpp"
#include "Movable.hpp"
#include "Scalable.hpp"

class Shape: public Movable, Scalable {

	protected:
		Point center;
		Shape(Point center);
	
	public:
		virtual ~Shape();
		virtual double area() = 0;
		virtual double perimeter() = 0;
		virtual bool inShape(Point p) = 0;
		virtual void move(Point p);
		virtual void scale(double scaleFactor) = 0;
};

#endif
